-- Copyright (C) 2009 Papavasileiou Dimitris                             
--                                                                      
-- This program is free software: you can redistribute it and/or modify 
-- it under the terms of the GNU General Public License as published by 
-- the Free Software Foundation, either version 3 of the License, or    
-- (at your option) any later version.                                  
--                                                                      
-- This program is distributed in the hope that it will be useful,      
-- but WITHOUT ANY WARRANTY; without even the implied warranty of       
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        
-- GNU General Public License for more details.                         
--                                                                      
-- You should have received a copy of the GNU General Public License    
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.

local h = 900

aviation.initial = {units.meters {5700, 1000, h}, units.knots (150), -90}
aviation.latitudes = {2, 6}
aviation.longitudes = {2, 6}
aviation.time = {142, 8}
aviation.turbidity = 2

-- The race-track setup.

airrace.sequence = {1, 2, 3, 4, 5, 6, 7}
airrace.gates = {
   airrace.gate {
      position = {5700, 500, h},
      rotation = 90,
      width = 20,
   },
   
   airrace.gate {
      position = {6000, 500, h},
      rotation = 90,
      width = 20,
   },

   airrace.gate {
      position = {6000, 1000, h},
      width = 200,
   },

   airrace.halfgate {
      position = {6000, 1200, h},
      width = 200,
   },

   airrace.halfgate {
      position = {6000, 1400, h},
      width = 200,
   },
   
   airrace.gate {
      position = {6000, 2000, h},
      rotation = 90,
      width = 20,
   },
   
   airrace.gate {
      position = {5500, 2000, h},
      rotation = 90,
      width = 20,
   },
}
